/* @(#)cgrefmap.sl	1.2	(CryslatGraphics Inc.)	11/12/90 */
/* Metallic Reflection Map shader for CrystalGraphics RIB files */
surface
cgmetal (float Ka=1, Ks=1, Kr = 1, Kd = 1, roughness=.1;
	    string texturename = "";)
{
    point Nf, D, V;
    color Cr;

    Nf = faceforward(normalize(N), I) ;
    V = normalize(-I);

    if (texturename != "") {
	Cr = Kr * color texture(texturename);
    } else {
	Cr = Cs;
    }

    Oi = Os;
    Ci = Os * Cs * ( Ka*ambient() + Ks*specular(Nf,V,roughness) + Cr);
}
