/* @(#)cgrefmap.sl	1.2	(CryslatGraphics Inc.)	11/12/90 */
/* Reflection Map shader for CrystalGraphics RIB files */
surface
cgrefmap (float Ka=1, Ks=1, Kr = 1, Kd = 1, roughness=.1;
	    string texturename = "";)
{
    point Nf, D, V;
    color Cr,Cx,Cy;

    Nf = faceforward(normalize(N), I) ;
    V = normalize(-I);

    if (texturename != "") {
	Cr = Kr * color texture(texturename);
    } else {
	Cr = Cs;
    }

    Oi = Os;
    Cy = Os * Cs * (Ka*ambient() + Kd * diffuse(Nf));
    Cx = Cy + (1 - Cy) * Ks * specular(Nf,V,roughness);
    Ci = Cx + (1 - Cx) * Cr;
}
